#include <stdio.h>
#include "ics.h"
#include <string.h>
#include <time.h>

int timeout=100;
int period=10*60;
//period has to be greater than timeout

volatile unsigned long long getTime () {
 unsigned int low,high;
 unsigned long long l,h;
  __asm__(".byte 0x0f,0x31" :"=a" (low), "=d" (high)); /* RDTSC */
  l=low;h=high;
  return (h<<32)+l;
}  

int httpread(char *servername,char* filename, int port,unsigned long long *elapsedTime,unsigned int *sz)

{
   int fd, temp;
   size_t n;
   char request[200], outbuffer[100000];
   char szClientA[100];   
   int readamount=0;  
   char *strOK="OK";
   char *x=(char *) calloc (100,sizeof(char));	   
   unsigned long long  starttime=0;
   sprintf(request,"GET %s HTTP/1.1\nhost:%s\nconnection:close\r\n\r\n",filename, servername);
   printf ("%s\n",request);
       starttime=getTime(); 
        if ((fd=open_clientfd(servername, port))<0)
                return fd;
        if ((temp=Writen(fd, request, strlen(request)))<0)
                return temp;
        for (;;)
        {
                n=read(fd,szClientA, 100);
                if (n<0)
                        return -5;
                else if (n==0)
                        break;
                else
                {
                        memcpy(outbuffer+readamount,szClientA,n);
                        readamount+=n;
                }
        }

	x=strstr(outbuffer,strOK);
	if (x==NULL)
		return -6;                
        *elapsedTime= (double) getTime() - (double)starttime;
	*sz=readamount;
        Close(fd);
        return 1;
    
}

void runner(char *servername, char *filename, int port)
{
 int available, pid, check;
 int rtr;
 FILE *output;
 time_t theTime;	
 struct tm *upTime;
 unsigned long long etime=0;
   unsigned int size_read=0;
	printf("starting %s %s %d\n", servername, filename, port);
	output=fopen(servername,"w");
	fclose(output);
	while (1)
	{
	  size_read=etime=0;
                if ((pid=fork())==0) //child
		{
			available=httpread(servername, filename, port,&etime,&size_read);
			output=fopen(servername,"a"); //append
			theTime=time(NULL);
			upTime=localtime(&theTime);
			printf("printing %d, 0x%x%x,%d,%s",available,  (unsigned int)(etime>>32), (unsigned int)(etime),size_read,asctime(upTime));
			fprintf(output,"%d, 0x%x%x,%d,%s",available,  (unsigned int)(etime>>32), (unsigned int)(etime),size_read,asctime(upTime));

			fclose(output);
			exit(0);			
		}
		sleep(timeout);

                rtr=waitpid(pid,&check,WNOHANG);
		
		if (rtr!=pid)
                {
			printf("timed out %s\n",servername);
                        //if the process still exists
                        kill(pid, SIGKILL);
                        waitpid(0, NULL, 0);
                        output=fopen(servername,"a"); //append
                        theTime=time(NULL);
                        upTime=localtime(&theTime);
			fprintf(output,"-7, 0x%x%x,%d,%s", (unsigned int)(etime>>32), (unsigned int)(etime),size_read,asctime(upTime));

                        fclose(output);                
                }

		sleep(period-timeout);
		printf("%s sleep\n",servername);
	}

}

int main(int argc, char **argv)
{	
 //first line of the file is the number of servers
 //then each line has a server name, filename and port number

 FILE *servers=fopen("servers.txt","r");
 char *serverlist[200];
 char *filelist[200];
 int portlist[200];
 char *tempstr;
 int i=0,pid, status;
 int NumofServers;
 char *x=(char *) calloc (100,sizeof(char));
	
	for (i=0; i<200; i++)
	{
		serverlist[i]=(char *) calloc (100,sizeof(char));
		filelist[i]=(char *) calloc (100,sizeof(char));	
	}

	tempstr=(char *) calloc (300,sizeof(char));	

	x=fgets(x,100,servers);	
	NumofServers=atoi(x);
	
	i=0;
	while (i<NumofServers)
	{ 
		tempstr=fgets(tempstr, 300, servers);
		tempstr[strlen(tempstr)-1]='\0';
		serverlist[i]=strcpy(serverlist[i],strtok(tempstr, " "));
		filelist[i]=strcpy(filelist[i],strtok(NULL, " "));
		portlist[i]=atoi(strtok(NULL, "\0"));
		i++;
	}
 
	for (i=0;i<NumofServers; i++){
		if ((pid=fork())==0) //child
		{
			runner(serverlist[i], filelist[i], portlist[i]);  
			exit(0);
		}
		sleep (period/NumofServers);
	}
	wait(&status);

}
#include <stdio.h>
#include "ics.h"
#include <string.h>
#include <time.h>

int timeout=100;
int period=10*60;
//period has to be greater than timeout

volatile unsigned long long getTime () {
 unsigned int low,high;
 unsigned long long l,h;
  __asm__(".byte 0x0f,0x31" :"=a" (low), "=d" (high)); /* RDTSC */
  l=low;h=high;
  return (h<<32)+l;
}  

int httpread(char *servername,char* filename, int port,unsigned long long *elapsedTime,unsigned int *sz)

{
   int fd, temp;
   size_t n;
   char request[200], outbuffer[100000];
   char szClientA[100];   
   int readamount=0;  
   char *strOK="OK";
   char *x=(char *) calloc (100,sizeof(char));	   
   unsigned long long  starttime=0;
   sprintf(request,"GET %s HTTP/1.1\nhost:%s\nconnection:close\r\n\r\n",filename, servername);
   printf ("%s\n",request);
       starttime=getTime(); 
        if ((fd=open_clientfd(servername, port))<0)
                return fd;
        if ((temp=Writen(fd, request, strlen(request)))<0)
                return temp;
        for (;;)
        {
                n=read(fd,szClientA, 100);
                if (n<0)
                        return -5;
                else if (n==0)
                        break;
                else
                {
                        memcpy(outbuffer+readamount,szClientA,n);
                        readamount+=n;
                }
        }

	x=strstr(outbuffer,strOK);
	if (x==NULL)
		return -6;                
        *elapsedTime= (double) getTime() - (double)starttime;
	*sz=readamount;
        Close(fd);
        return 1;
    
}

void runner(char *servername, char *filename, int port)
{
 int available, pid, check;
 int rtr;
 FILE *output;
 time_t theTime;	
 struct tm *upTime;
 unsigned long long etime=0;
   unsigned int size_read=0;
	printf("starting %s %s %d\n", servername, filename, port);
	output=fopen(servername,"w");
	fclose(output);
	while (1)
	{
	  size_read=etime=0;
                if ((pid=fork())==0) //child
		{
			available=httpread(servername, filename, port,&etime,&size_read);
			output=fopen(servername,"a"); //append
			theTime=time(NULL);
			upTime=localtime(&theTime);
			printf("printing %d, 0x%x%x,%d,%s",available,  (unsigned int)(etime>>32), (unsigned int)(etime),size_read,asctime(upTime));
			fprintf(output,"%d, 0x%x%x,%d,%s",available,  (unsigned int)(etime>>32), (unsigned int)(etime),size_read,asctime(upTime));

			fclose(output);
			exit(0);			
		}
		sleep(timeout);

                rtr=waitpid(pid,&check,WNOHANG);
		
		if (rtr!=pid)
                {
			printf("timed out %s\n",servername);
                        //if the process still exists
                        kill(pid, SIGKILL);
                        waitpid(0, NULL, 0);
                        output=fopen(servername,"a"); //append
                        theTime=time(NULL);
                        upTime=localtime(&theTime);
			fprintf(output,"-7, 0x%x%x,%d,%s", (unsigned int)(etime>>32), (unsigned int)(etime),size_read,asctime(upTime));

                        fclose(output);                
                }

		sleep(period-timeout);
		printf("%s sleep\n",servername);
	}

}

int main(int argc, char **argv)
{	
 //first line of the file is the number of servers
 //then each line has a server name, filename and port number

 FILE *servers=fopen("servers.txt","r");
 char *serverlist[200];
 char *filelist[200];
 int portlist[200];
 char *tempstr;
 int i=0,pid, status;
 int NumofServers;
 char *x=(char *) calloc (100,sizeof(char));
	
	for (i=0; i<200; i++)
	{
		serverlist[i]=(char *) calloc (100,sizeof(char));
		filelist[i]=(char *) calloc (100,sizeof(char));	
	}

	tempstr=(char *) calloc (300,sizeof(char));	

	x=fgets(x,100,servers);	
	NumofServers=atoi(x);
	
	i=0;
	while (i<NumofServers)
	{ 
		tempstr=fgets(tempstr, 300, servers);
		tempstr[strlen(tempstr)-1]='\0';
		serverlist[i]=strcpy(serverlist[i],strtok(tempstr, " "));
		filelist[i]=strcpy(filelist[i],strtok(NULL, " "));
		portlist[i]=atoi(strtok(NULL, "\0"));
		i++;
	}
 
	for (i=0;i<NumofServers; i++){
		if ((pid=fork())==0) //child
		{
			runner(serverlist[i], filelist[i], portlist[i]);  
			exit(0);
		}
		sleep (period/NumofServers);
	}
	wait(&status);

}
